/********************************** (C) COPYRIGHT *******************************
* File Name          : ROOT_UDISKIF.C
* Author             : WCH
* Version            : V1.1
* Date               : 2015/10/13
* Description        : CH559 U̶д Interface                                  				   
*******************************************************************************/
#include "CH559.H"
//ҪLIBļ
#include "USB_LIB/CH559UFI.H"
#include "USB_LIB/CH559UFI.C"

// ȡ豸
UINT8C  SetupGetDevDescr[] = { USB_REQ_TYP_IN, USB_GET_DESCRIPTOR, 0x00, USB_DESCR_TYP_DEVICE, 0x00, 0x00, sizeof( USB_DEV_DESCR ), 0x00 };
// ȡ
UINT8C  SetupGetCfgDescr[] = { USB_REQ_TYP_IN, USB_GET_DESCRIPTOR, 0x00, USB_DESCR_TYP_CONFIG, 0x00, 0x00, 0x04, 0x00 };
// USBַ
UINT8C  SetupSetUsbAddr[] = { USB_REQ_TYP_OUT, USB_SET_ADDRESS, USB_DEVICE_ADDR, 0x00, 0x00, 0x00, 0x00, 0x00 };
// USB
UINT8C  SetupSetUsbConfig[] = { USB_REQ_TYP_OUT, USB_SET_CONFIGURATION, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 };
// ˵STALL
UINT8C  SetupClrEndpStall[] = { USB_REQ_TYP_OUT | USB_REQ_RECIP_ENDP, USB_CLEAR_FEATURE, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 };
UINT8X  RxBuffer[ MAX_PACKET_SIZE ] _at_ 0x0000 ;  // IN, must even address
UINT8X  TxBuffer[ MAX_PACKET_SIZE ] _at_ 0x0040 ;  // OUT, must even address


/*******************************************************************************
* Function Name  : DisableRootHubPort( void )
* Description    : رRoothub˿
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void   DisableRootHubPort( void )      // رն˿,ʵӲѾԶر,˴ֻһЩṹ״̬
{
    CH559DiskStatus = DISK_DISCONNECT;
    UHUB0_CTRL = 0x00;                 // йHUB0Ŀ,ʵϲҪ
}

/*******************************************************************************
* Function Name  : AnalyzeRootHub( void )
* Description    : ˿״̬
* Input          : None
* Output         : None
* Return         : UINT8 s
*******************************************************************************/
UINT8   AnalyzeRootHub( void )         // ˿״̬,˿ڵ豸¼
// ERR_SUCCESSΪû,ERR_USB_CONNECTΪ⵽,ERR_USB_DISCONΪ⵽Ͽ
{
//˿ڵĲ¼,豸γ,еDisableRootHubPort(),˿ڹر,¼,Ӧ˿ڵ״̬λ
    UINT8   s;
    s = ERR_SUCCESS;
    if ( USB_HUB_ST & bUHS_H0_ATTACH ) // 豸
    {
        if ( CH559DiskStatus == DISK_DISCONNECT || ( UHUB0_CTRL & bUH_PORT_EN ) == 0x00 )    // ⵽豸,δ,˵Ǹղ
        {
            DisableRootHubPort( );     // رն˿
            CH559DiskStatus = DISK_CONNECT;
            s = ERR_USB_CONNECT;
        }
    }
    else if ( CH559DiskStatus >= DISK_CONNECT )
    {
        DisableRootHubPort( );         // رն˿
        if ( s == ERR_SUCCESS )
        {
            s = ERR_USB_DISCON;
        }
    }
    return( s );
}

/*******************************************************************************
* Function Name  : SetHostUsbAddr( UINT8 addr )
* Description    : USBǰUSB豸ַ
* Input          : UINT8 addr
* Output         : None
* Return         : None
*******************************************************************************/
void   SetHostUsbAddr( UINT8 addr )  
{
    USB_DEV_AD = USB_DEV_AD & bUDA_GP_BIT | addr & 0x7F;
}

/*******************************************************************************
* Function Name  : ResetRootHubPort( void )
* Description    : ⵽豸,λ,Ϊö豸׼,ΪĬΪȫ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void   ResetRootHubPort( void )        
{
    UsbDevEndp0Size = DEFAULT_ENDP0_SIZE;  /* USB豸Ķ˵0ߴ */
    SetHostUsbAddr( 0x00 );
    SetUsbSpeed( 1 );                   // ĬΪȫ
    UHUB0_CTRL = UHUB0_CTRL & ~ bUH_LOW_SPEED | bUH_BUS_RESET;  // ĬΪȫ,ʼλ
    mDelaymS( 15 );                     // λʱ10mS20mS
    UHUB0_CTRL = UHUB0_CTRL & ~ bUH_BUS_RESET;  // λ
    mDelayuS( 250 );
    UIF_DETECT = 0;                     // жϱ־
}

/*******************************************************************************
* Function Name  : EnableRootHubPort( void )
* Description    : ʹܶ˿,ӦbUH_PORT_EN1˿,豸Ͽܵ·ʧ
* Input          : None
* Output         : None
* Return         : ERR_USB_DISCON
*******************************************************************************/
UINT8   EnableRootHubPort( void )  
{
    if ( CH559DiskStatus < DISK_CONNECT )
    {
        CH559DiskStatus = DISK_CONNECT;
    }
    if ( USB_HUB_ST & bUHS_H0_ATTACH )    // 豸
    {
        UHUB0_CTRL |= bUH_PORT_EN;  //ʹHUB˿
        return( ERR_SUCCESS );
    }
    return( ERR_USB_DISCON );
}

/*******************************************************************************
* Function Name  : WaitUSB_Interrupt( void )
* Description    : ȴUSBж
* Input          : None
* Output         : None
* Return         : UIF_TRANSFER ? ERR_SUCCESS : ERR_USB_UNKNOWN
*******************************************************************************/
UINT8   WaitUSB_Interrupt( void )  
{
    UINT16  i;
    for ( i = WAIT_USB_TOUT_200US; i != 0 && UIF_TRANSFER == 0; i -- )
    {
        ;
    }
    return( UIF_TRANSFER ? ERR_SUCCESS : ERR_USB_UNKNOWN );
}

/*******************************************************************************
* Function Name  : USBHostTransact( UINT8 endp_pid, UINT8 tog, UINT16 timeout )
* Description    : CH559,ĿĶ˵ַ/PID,ͬ־,20uSΪλNAKʱ(0,0xFFFF),0ɹ,ʱ/
* Input          : UINT8 endp_pid, UINT8 tog, UINT16 timeout
* Output         : None
* Return         : some
*******************************************************************************/ 
UINT8   USBHostTransact( UINT8 endp_pid, UINT8 tog, UINT16 timeout )  // endp_pid: 4λtoken_pid, 4λǶ˵ַ
{
 // ӳ,ʵӦ,Ϊṩٶ,ӦöԱӳŻ
    #define TransRetry  UEP0_T_LEN  // Լڴ
    UINT8   s, r;
    UINT16  i;
    UH_RX_CTRL = UH_TX_CTRL = tog;
    TransRetry = 0;
    do
    {
        UH_EP_PID = endp_pid;  // ָPIDĿĶ˵
        UIF_TRANSFER = 0;  // 
        for ( i = WAIT_USB_TOUT_200US; i != 0 && UIF_TRANSFER == 0; i -- )
        {
            ;
        }
        UH_EP_PID = 0x00;  // ֹͣUSB
        if ( UIF_TRANSFER == 0 )
        {
            return( ERR_USB_UNKNOWN );
        }
        if ( UIF_DETECT )    // USB豸¼
        {
            UIF_DETECT = 0;  // жϱ־
            s = AnalyzeRootHub( );   // ROOT-HUB״̬
            if ( s == ERR_USB_CONNECT )
            {
                FoundNewDev = 1;
            }
            if ( CH559DiskStatus == DISK_DISCONNECT )
            {
                return( ERR_USB_DISCON );    // USB豸Ͽ¼
            }
            if ( CH559DiskStatus == DISK_CONNECT )
            {
                return( ERR_USB_CONNECT );    // USB豸¼
            }
            mDelayuS( 200 );  // ȴ
        }
        if ( UIF_TRANSFER )    // 
        {
            if ( U_TOG_OK )
            {
                return( ERR_SUCCESS );
            }
#ifdef DEBUG_NOW
            printf("endp_pid=%02X\n",(UINT16)endp_pid);
            printf("USB_INT_FG=%02X\n",(UINT16)USB_INT_FG);
            printf("USB_INT_ST=%02X\n",(UINT16)USB_INT_ST);
            printf("USB_MIS_ST=%02X\n",(UINT16)USB_MIS_ST);
            printf("USB_RX_LEN=%02X\n",(UINT16)USB_RX_LEN);
            printf("UH_TX_LEN=%02X\n",(UINT16)UH_TX_LEN);
            printf("UH_RX_CTRL=%02X\n",(UINT16)UH_RX_CTRL);
            printf("UH_TX_CTRL=%02X\n",(UINT16)UH_TX_CTRL);
            printf("UHUB0_CTRL=%02X\n",(UINT16)UHUB0_CTRL);
            printf("UHUB1_CTRL=%02X\n",(UINT16)UHUB1_CTRL);
#endif
            r = USB_INT_ST & MASK_UIS_H_RES;  // USB豸Ӧ״̬
            if ( r == USB_PID_STALL )
            {
                return( r | ERR_USB_TRANSFER );
            }
            if ( r == USB_PID_NAK )
            {
                if ( timeout == 0 )
                {
                    return( r | ERR_USB_TRANSFER );
                }
                if ( timeout < 0xFFFF )
                {
                    timeout --;
                }
                -- TransRetry;
            }
            else switch ( endp_pid >> 4 )
                {
                case USB_PID_SETUP:
                case USB_PID_OUT:
                    if ( r )
                    {
                        return( r | ERR_USB_TRANSFER );    // ǳʱ/,Ӧ
                    }
                    break;  // ʱ
                case USB_PID_IN:
                    if ( r == USB_PID_DATA0 && r == USB_PID_DATA1 )    // ͬ趪
                    {
                    }  // ͬ
                    else if ( r )
                    {
                        return( r | ERR_USB_TRANSFER );    // ǳʱ/,Ӧ
                    }
                    break;  // ʱ
                default:
                    return( ERR_USB_UNKNOWN );  // ܵ
                    break;
                }
        }
        else    // ж,Ӧ÷
        {
            USB_INT_FG = 0xFF;  /* жϱ־ */
        }
        mDelayuS( 15 );
    }
    while ( ++ TransRetry < 3 );
    return( ERR_USB_TRANSFER );  // Ӧʱ
}

/*******************************************************************************
* Function Name  : HostCtrlTransfer( PUINT8X DataBuf, PUINT8I RetLen )
* Description    : ִпƴ,8ֽpSetupReq,DataBufΪѡշ
* Input          : PUINT8X DataBuf, PUINT8I RetLen
* Output         : None
* Return         : some
*******************************************************************************/
UINT8   HostCtrlTransfer( PUINT8X DataBuf, PUINT8I RetLen )  
// Ҫպͷ,ôDataBufָЧڴź,ʵʳɹշܳȱReqLenָֽڱ
{
    UINT8   s, RemLen, RxLen, RxCnt, TxCnt;
    PUINT8X xdata   pBuf;
    PUINT8I xdata   pLen;
    pBuf = DataBuf;
    pLen = RetLen;
    mDelayuS( 200 );
    if ( pLen )
    {
        *pLen = 0;    // ʵʳɹշܳ
    }
    UH_TX_LEN = sizeof( USB_SETUP_REQ );
    s = USBHostTransact( USB_PID_SETUP << 4 | 0x00, 0x00, 200000/20 );  // SETUP׶,200mSʱ
    if ( s != ERR_SUCCESS )
    {
        return( s );
    }
    UH_RX_CTRL = UH_TX_CTRL = bUH_R_TOG | bUH_R_AUTO_TOG | bUH_T_TOG | bUH_T_AUTO_TOG;  // ĬDATA1
    UH_TX_LEN = 0x01;  // Ĭݹ״̬׶ΪIN
    RemLen = pSetupReq -> wLengthH ? 0xFF : pSetupReq -> wLengthL;
    if ( RemLen && pBuf )    // Ҫշ
    {
        if ( pSetupReq -> bRequestType & USB_REQ_TYP_IN )    // 
        {
            while ( RemLen )
            {
                mDelayuS( 200 );
                s = USBHostTransact( USB_PID_IN << 4 | 0x00, UH_RX_CTRL, 200000/20 );  // IN
                if ( s != ERR_SUCCESS )
                {
                    return( s );
                }
                RxLen = USB_RX_LEN < RemLen ? USB_RX_LEN : RemLen;
                RemLen -= RxLen;
                if ( pLen )
                {
                    *pLen += RxLen;    // ʵʳɹշܳ
                }
                for ( RxCnt = 0; RxCnt != RxLen; RxCnt ++ )
                {
                    *pBuf = RxBuffer[ RxCnt ];
                    pBuf ++;
                }
                if ( USB_RX_LEN == 0 || ( USB_RX_LEN & ( UsbDevEndp0Size - 1 ) ) )
                {
                    break;    // ̰
                }
            }
            UH_TX_LEN = 0x00;  // ״̬׶ΪOUT
        }
        else    // 
        {
            while ( RemLen )
            {
                mDelayuS( 200 );
                UH_TX_LEN = RemLen >= UsbDevEndp0Size ? UsbDevEndp0Size : RemLen;
                for ( TxCnt = 0; TxCnt != UH_TX_LEN; TxCnt ++ )
                {
                    TxBuffer[ TxCnt ] = *pBuf;
                    pBuf ++;
                }
                s = USBHostTransact( USB_PID_OUT << 4 | 0x00, UH_TX_CTRL, 200000/20 );  // OUT
                if ( s != ERR_SUCCESS )
                {
                    return( s );
                }
                RemLen -= UH_TX_LEN;
                if ( pLen )
                {
                    *pLen += UH_TX_LEN;    // ʵʳɹշܳ
                }
            }
        }
    }
    mDelayuS( 200 );
    s = USBHostTransact( ( UH_TX_LEN ? USB_PID_IN << 4 | 0x00: USB_PID_OUT << 4 | 0x00 ), bUH_R_TOG | bUH_T_TOG, 200000/20 );  // STATUS׶
    if ( s != ERR_SUCCESS )
    {
        return( s );
    }
    if ( UH_TX_LEN == 0 )
    {
        return( ERR_SUCCESS );    // ״̬OUT
    }
    if ( USB_RX_LEN == 0 )
    {
        return( ERR_SUCCESS );    // ״̬IN,IN״̬ݳ
    }
    return( ERR_USB_BUF_OVER );  // IN״̬׶δ
}

/*******************************************************************************
* Function Name  : CopySetupReqPkg( PUINT8C pReqPkt )
* Description    : ƿƴ
* Input          : PUINT8C pReqPkt
* Output         : None
* Return         : None
*******************************************************************************/
void   CopySetupReqPkg( PUINT8C pReqPkt )  
{
    UINT8   i;
    for ( i = 0; i != sizeof( USB_SETUP_REQ ); i ++ )
    {
        ((PUINT8X)pSetupReq)[ i ] = *pReqPkt;
        pReqPkt ++;
    }
}

/*******************************************************************************
* Function Name  : CtrlGetDeviceDescr( void )
* Description    : ȡ豸,TxBuffer
* Input          : None
* Output         : None
* Return         : some
*******************************************************************************/
UINT8   CtrlGetDeviceDescr( void )  
{
    UINT8   s;
    UINT8D  len;
    UsbDevEndp0Size = DEFAULT_ENDP0_SIZE;
    CopySetupReqPkg( SetupGetDevDescr );
    s = HostCtrlTransfer( TxBuffer, &len );  // ִпƴ
    if ( s != ERR_SUCCESS )
    {
        return( s );
    }
    UsbDevEndp0Size = ( (PXUSB_DEV_DESCR)TxBuffer ) -> bMaxPacketSize0;  // ˵0,Ǽ򻯴,ӦȻȡǰ8ֽںUsbDevEndp0Sizeټ
    if ( len < ( (PUSB_SETUP_REQ)SetupGetDevDescr ) -> wLengthL )
    {
        return( ERR_USB_BUF_OVER );    // ȴ
    }
    return( ERR_SUCCESS );
}

/*******************************************************************************
* Function Name  : CtrlGetConfigDescr( void )
* Description    : ȡ,TxBuffer
* Input          : None
* Output         : None
* Return         : some
*******************************************************************************/
UINT8   CtrlGetConfigDescr( void ) 
{
    UINT8   s;
    UINT8D  len;
    CopySetupReqPkg( SetupGetCfgDescr );
    s = HostCtrlTransfer( TxBuffer, &len );  // ִпƴ
    if ( s != ERR_SUCCESS )
    {
        return( s );
    }
    if ( len < ( (PUSB_SETUP_REQ)SetupGetCfgDescr ) -> wLengthL )
    {
        return( ERR_USB_BUF_OVER );    // سȴ
    }
    len = ( (PXUSB_CFG_DESCR)TxBuffer ) -> wTotalLengthL;
    if ( len > MAX_PACKET_SIZE )
    {
        return( ERR_USB_BUF_OVER );    // سȴ
    }
    CopySetupReqPkg( SetupGetCfgDescr );
    pSetupReq -> wLengthL = len;  // ܳ
    s = HostCtrlTransfer( TxBuffer, &len );  // ִпƴ
    if ( s != ERR_SUCCESS )
    {
        return( s );
    }
    if ( len < ( (PUSB_SETUP_REQ)SetupGetCfgDescr ) -> wLengthL || len < ( (PXUSB_CFG_DESCR)TxBuffer ) -> wTotalLengthL )
    {
        return( ERR_USB_BUF_OVER );    // ȴ
    }
    return( ERR_SUCCESS );
}

/*******************************************************************************
* Function Name  : CtrlSetUsbAddress( UINT8 addr )
* Description    : USB豸ַ
* Input          : UINT8 addr
* Output         : None
* Return         : some
*******************************************************************************/
UINT8   CtrlSetUsbAddress( UINT8 addr )  // USB豸ַ
{
    UINT8   s;
    CopySetupReqPkg( SetupSetUsbAddr );
    pSetupReq -> wValueL = addr;  // USB豸ַ
    s = HostCtrlTransfer( NULL, NULL );  // ִпƴ
    if ( s != ERR_SUCCESS )
    {
        return( s );
    }
    SetHostUsbAddr( addr );  // USBǰUSB豸ַ
    mDelaymS( 10 );  // ȴUSB豸ɲ
    return( ERR_SUCCESS );
}

/*******************************************************************************
* Function Name  : CtrlSetUsbConfig( UINT8 cfg )
* Description    : USB豸
* Input          : UINT8 cfg
* Output         : None
* Return         : HostCtrlTransfer( NULL, NULL )
*******************************************************************************/
UINT8   CtrlSetUsbConfig( UINT8 cfg )  // USB豸
{
    CopySetupReqPkg( SetupSetUsbConfig );
    pSetupReq -> wValueL = cfg;  // USB豸
    return( HostCtrlTransfer( NULL, NULL ) );  // ִпƴ
}

/*******************************************************************************
* Function Name  : CtrlClearEndpStall( UINT8 endp )
* Description    : ˵STALL
* Input          : UINT8 endp
* Output         : None
* Return         : HostCtrlTransfer( NULL, NULL )
*******************************************************************************/
UINT8   CtrlClearEndpStall( UINT8 endp )  // ˵STALL
{
    CopySetupReqPkg( SetupClrEndpStall );  // ˵Ĵ
    pSetupReq -> wIndexL = endp;  // ˵ַ
    return( HostCtrlTransfer( NULL, NULL ) );  /* ִпƴ */
}

/*******************************************************************************
* Function Name  : AnalyzeHidIntEndp( PUINT8X buf )
* Description    : зHIDж϶˵ĵַ
* Input          : PUINT8X buf
* Output         : None
* Return         : UINT8 s
*******************************************************************************/
UINT8   AnalyzeHidIntEndp( PUINT8X buf )  // зHIDж϶˵ĵַ
{
    UINT8   i, s, l;
    s = 0;
    for ( i = 0; i < ( (PXUSB_CFG_DESCR)buf ) -> wTotalLengthL; i += l )    // ж϶˵,ͽӿ
    {
        if ( ( (PXUSB_ENDP_DESCR)(buf+i) ) -> bDescriptorType == USB_DESCR_TYP_ENDP  // Ƕ˵
                && ( ( (PXUSB_ENDP_DESCR)(buf+i) ) -> bmAttributes & USB_ENDP_TYPE_MASK ) == USB_ENDP_TYPE_INTER  // ж϶˵
                && ( ( (PXUSB_ENDP_DESCR)(buf+i) ) -> bEndpointAddress & USB_ENDP_DIR_MASK ) )    // IN˵
        {
            s = ( (PXUSB_ENDP_DESCR)(buf+i) ) -> bEndpointAddress & USB_ENDP_ADDR_MASK;  // ж϶˵ĵַ
            break;  // ԸҪwMaxPacketSizebInterval
        }
        l = ( (PXUSB_ENDP_DESCR)(buf+i) ) -> bLength;  // ǰ,
        if ( l > 16 )
        {
            break;
        }
    }
    return( s );
}

/*******************************************************************************
* Function Name  : InitRootDevice( void )
* Description    : ʼUSB豸
* Input          : None
* Output         : None
* Return         : some
*******************************************************************************/
UINT8   InitRootDevice( void )  // ʼUSB豸
{
    UINT8   i, s, cfg, dv_cls, if_cls;
    ResetRootHubPort( );  // ⵽豸,λӦ˿ڵUSB
    for ( i = 0, s = 0; i < 100; i ++ )    // ȴUSB豸λ,100mSʱ
    {
        mDelaymS( 1 );
        if ( EnableRootHubPort( ) == ERR_SUCCESS )    // ʹܶ˿
        {
            i = 0;
            s ++;  // ʱȴUSB豸Ӻȶ
            if ( s > 100 )
            {
                break;    // Ѿȶ100mS
            }
        }
    }
    if ( i )    // λ豸û
    {
        DisableRootHubPort( );
        return( ERR_USB_DISCON );
    }
    SetUsbSpeed( ThisUsbDev.DeviceSpeed );  // õǰUSBٶ
    s = CtrlGetDeviceDescr( );  // ȡ豸
    if ( s == ERR_SUCCESS )
    {
        for ( i = 0; i < ( (PUSB_SETUP_REQ)SetupGetDevDescr ) -> wLengthL; i ++ )
        {
           ;
        }
        dv_cls = ( (PXUSB_DEV_DESCR)TxBuffer ) -> bDeviceClass;  // 豸
        s = CtrlSetUsbAddress( ( (PUSB_SETUP_REQ)SetupSetUsbAddr ) -> wValueL );  // USB豸ַ
        if ( s == ERR_SUCCESS )
        {
            s = CtrlGetConfigDescr( );  // ȡ
            if ( s == ERR_SUCCESS )
            {
                cfg = ( (PXUSB_CFG_DESCR)TxBuffer ) -> bConfigurationValue;
                for ( i = 0; i < ( (PXUSB_CFG_DESCR)TxBuffer ) -> wTotalLengthL; i ++ )
                {
                  ; 
                }
                /* ,ȡ˵/˵ַ/˵С,±endp_addrendp_size */
                if_cls = ( (PXUSB_CFG_DESCR_LONG)TxBuffer ) -> itf_descr.bInterfaceClass;  // ӿ
                if ( dv_cls == 0x00 && if_cls == USB_DEV_CLASS_STORAGE )    // USB洢豸,ȷU
                {
                    CH559DiskStatus = DISK_USB_ADDR;
                    return( ERR_SUCCESS );
                }
                else
                {
                    return( ERR_USB_UNSUPPORT );
                }
            }
        }
    }
    CH559DiskStatus = DISK_CONNECT;
    SetUsbSpeed( 1 );  // ĬΪȫ
    return( s );
}

/*******************************************************************************
* Function Name  : InitUSB_Host( void )
* Description    : ʼUSB
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void    InitUSB_Host( void )  // ʼUSB
{
    IE_USB = 0;
    USB_CTRL = bUC_HOST_MODE;  // 趨ģʽ
    USB_DEV_AD = 0x00;
    UH_EP_MOD = bUH_EP_TX_EN | bUH_EP_RX_EN ;
    UH_RX_DMA = RxBuffer;
    UH_TX_DMA = TxBuffer;
    UH_RX_CTRL = 0x00;
    UH_TX_CTRL = 0x00;
    USB_CTRL = bUC_HOST_MODE | bUC_INT_BUSY | bUC_DMA_EN;  // USBDMA,жϱ־δǰԶͣ
    UH_SETUP = bUH_SOF_EN;
    USB_INT_FG |= 0xFF;  // жϱ־
    DisableRootHubPort( );  // 
    USB_INT_EN = bUIE_TRANSFER | bUIE_DETECT;
}

/*******************************************************************************
* Function Name  : mStopIfError( UINT8 iError )
* Description    : ״̬,ʾ벢ͣ
* Input          : UINT8 iError
* Output         : None
* Return         : None
*******************************************************************************/
void    mStopIfError( UINT8 iError )
{
    if ( iError == ERR_SUCCESS )
    {
        return;    /* ɹ */
    }
    printf( "Error: %02X\n", (UINT16)iError );  /* ʾ */
    /* ,Ӧ÷ԼCH559DiskStatus״̬,CH559DiskReadyѯǰUǷ,UѶϿôµȴU̲ٲ,
       Ĵ:
       1һCH559DiskReady,ɹ,Open,Read/Write
       2CH559DiskReadyɹ,ôǿнͷʼ(ȴUӣCH559DiskReady) */
    while ( 1 )
    {
//      LED_TMP=0;  /* LED˸ */
//      mDelaymS( 100 );
//      LED_TMP=1;
//      mDelaymS( 100 );
    }
}